class Help {
    data = {
        page_prev: {
            key: "z",
            text: "一つ前の教材へ移動します",
        },
        page_next: {
            key: "x",
            text: "一つ後の教材へ移動します",
        },

        "2章": {
            key: "",
            text: "2章へ移動します",
        },
        "3章": {
            key: "",
            text: "3章へ移動します",
        },
        "4章": {
            key: "",
            text: "4章へ移動します",
        },
        "5章": {
            key: "",
            text: "5章へ移動します",
        },
        "6章": {
            key: "",
            text: "6章へ移動します",
        },
        "7章": {
            key: "",
            text: "7章へ移動します",
        },
        "8章": {
            key: "",
            text: "8章へ移動します",
        },
        "9章": {
            key: "",
            text: "9章へ移動します",
        },
        "10章": {
            key: "",
            text: "10章へ移動します",
        },
        "11章": {
            key: "",
            text: "11章へ移動します",
        },
        "12章": {
            key: "",
            text: "12章へ移動します",
        },
        "13章": {
            key: "",
            text: "13章へ移動します",
        },
        "14章": {
            key: "",
            text: "14章へ移動します",
        },
        "15章": {
            key: "",
            text: "15章へ移動します",
        },

        appendix_button: {
            key: "q",
            text: "資料の表示のON/OFFを切り替えます",
        },
        search_button: {
            key: "w",
            text: "検索画面の表示のON/OFFを切り替えます",
        },
        config_button: {
            key: "e",
            text: "設定画面の表示のON/OFFを切り替えます",
        },
        show_description: {
            key: "r",
            text: "説明文の表示の最小化を解除して表示します",
        },
        show_execute: {
            key: "t",
            text: "プログラムの実行結果の表示の最小化を解除して表示します",
        },
        shortcut_button: {
            key: "@",
            text: "ON にすることで、ショートカットキーでボタンの操作を行うことができるようになります<br>このボタンのショートカットキーのみ、OFF の状態でも操作を受け付けます",
        },
        help_button: {
            key: "[",
            text: "ON にすることで、ボタンなど、赤い枠が表示された部分の上に<br>マウスを移動すると、説明が表示されるようになります",
        },

        execute_minmax: {
            key: "t",
            text: "プログラムの実行結果の表示を最小化します。<br>最小化後に、上部に表示される「実行結果」ボタンを<br>クリックすると再び表示されるようになります",
        },

        HTML_selector: {
            key: "a",
            text: "HTML文章を表示します",
        },
        CSS_selector: {
            key: "s",
            text: "CSSを表示します",
        },
        Javascript_selector: {
            key: "d",
            text: "JavaScriptを表示します",
        },
        start_execute: {
            key: "f",
            text: "プログラムを再実行します",
        },
        debug: {
            key: "g",
            text: "デベロッパーツールの「ソース」に、JavaScript の<br>プログラムを表示し、最初の行で停止状態にし、<br>ブレークポイントを使ったデバッグを行えるようにします",
        },
        diff: {
            key: "h",
            text: "プログラムの比較の表示のON/OFFを切り替えます",
        },
        comment: {
            key: "j",
            text: "プログラムのコメントの表示のON/OFFを切り替えます",
        },
        diff_box: {
            key: "k",
            text: "比較ボックスの表示のON/OFFを切り替えますを表示します",
        },
        diff_clipboard: {
            key: "l",
            text: "クリップボードの内容と比較します<br>比較を行う際に、クリック後に表示されるパネルの<br>「許可」をクリックする必要があります",
        },
        diff_file: {
            key: ";",
            text: "選択したファイルの内容と比較します",
        },
        copy: {
            key: ":",
            text: "下記の内容をクリップボードにコピーします",
        },

        appendix_prev: {
            key: "c",
            text: "一つ前の資料の表示へ戻ります",
        },
        appendix_next: {
            key: "v",
            text: "一つ後の資料の表示へ戻ります",
        },
        appendix_min: {
            key: "e",
            text: "資料の表示履歴を保ったまま、資料の表示を最小化します",
        },
        appendix_close: {
            key: "",
            text: "資料の表示を閉じます<br>その際に、資料の表示履歴はクリアされます",
        },

        search_text: {
            key: "",
            text: "検索ワードを入力するテキストボックスです<br>空白で区切ることで、全ての検索ワードが入った内容に、検索結果を絞り込むことができます",
        },
        start_search: {
            key: "",
            text: "検索を実行します<br>テキストボックスでエンターキーを押して実行することもできます",
        },
        search_option_button: {
            key: "b",
            text: "検索オブションの画面に移動します",
        },
        search_close: {
            key: "w",
            text: "検索画面を閉じます",
        },

        search_material_help: {
            key: "",
            text: "教材を検索の対象とするかどうかを設定します",
        },
        search_material_true: {
            key: "",
            text: "教材を検索の対象とします",
        },
        search_material_false: {
            key: "",
            text: "教材を検索の対象としません",
        },

        search_material_type_help: {
            key: "",
            text: "検索の対象とする、教材の種類を設定します",
        },
        search_material_type_main: {
            key: "",
            text: "[JS1] など、本書が直接対象とする教材を検索の対象とします",
        },
        search_material_type_misc: {
            key: "",
            text: "[例1] など、本書で例として取り上げた教材を検索の対象とします",
        },
        search_material_type_sup: {
            key: "",
            text: "[補足1] など、本書で補足として取り上げた教材を検索の対象とします",
        },
        search_material_type_question: {
            key: "",
            text: "[章末問題] や [ヒント1] など、本書の章末問題に関する教材を検索の対象とします",
        },
        search_material_type_all: {
            key: "",
            text: "左の全ての検索条件を ON にします",
        },
        search_material_type_clear: {
            key: "",
            text: "左の全ての検索条件を OFF にします",
        },

        search_material_description_help: {
            key: "",
            text: "教材の説明文の検索対象を設定します",
        },
        search_material_description_all: {
            key: "",
            text: "教材の説明文のすべての文章を検索の対象とします",
        },
        search_material_description_heading: {
            key: "",
            text: "教材の説明文の見出しの部分のみを検索の対象とします",
        },
        search_material_description_none: {
            key: "",
            text: "教材の説明文を検索の対象としません",
        },

        search_material_code_help: {
            key: "",
            text: "教材のプログラムの検索対象を設定します",
        },
        search_material_code_all: {
            key: "",
            text: "HTML, CSS, Javascript すべてを検索対象とします",
        },
        search_material_code_html: {
            key: "",
            text: "HTML のみを検索対象とします",
        },
        search_material_code_css: {
            key: "",
            text: "CSS のみを検索対象とします",
        },
        search_material_code_script: {
            key: "",
            text: "Javascript のみを検索対象とします",
        },
        search_material_code_none: {
            key: "",
            text: "プログラムの部分を検索の対象としません",
        },
        search_material_code_line_same: {
            key: "",
            text: "検索ワードを空白で区切って複数指定した場合、<br>同じ行にすべての検索ワードが存在する場合のみ検索します",
        },
        search_material_code_word_same: {
            key: "",
            text: "検索ワードと単語レベルで一致する場合のみ検索します<br>例：検索ワードに doc を指定した場合、document は検索の対象となりません",
        },

        search_material_chapter_help: {
            key: "",
            text: "検索の対象とする章を設定します",
        },
        search_material_chapter_2: {
            key: "",
            text: "2章を検索の対象とします",
        },
        search_material_chapter_3: {
            key: "",
            text: "3章を検索の対象とします",
        },
        search_material_chapter_4: {
            key: "",
            text: "4章を検索の対象とします",
        },
        search_material_chapter_5: {
            key: "",
            text: "5章を検索の対象とします",
        },
        search_material_chapter_6: {
            key: "",
            text: "6章を検索の対象とします",
        },
        search_material_chapter_7: {
            key: "",
            text: "7章を検索の対象とします",
        },
        search_material_chapter_8: {
            key: "",
            text: "8章を検索の対象とします",
        },
        search_material_chapter_9: {
            key: "",
            text: "9章を検索の対象とします",
        },
        search_material_chapter_10: {
            key: "",
            text: "10章を検索の対象とします",
        },
        search_material_chapter_11: {
            key: "",
            text: "11章を検索の対象とします",
        },
        search_material_chapter_12: {
            key: "",
            text: "12章を検索の対象とします",
        },
        search_material_chapter_13: {
            key: "",
            text: "13章を検索の対象とします",
        },
        search_material_chapter_14: {
            key: "",
            text: "14章を検索の対象とします",
        },
        search_material_chapter_15: {
            key: "",
            text: "15章を検索の対象とします",
        },
        search_material_chapter_all: {
            key: "",
            text: "左の全ての章を ON にします",
        },
        search_material_chapter_clear: {
            key: "",
            text: "左の全ての章を OFF にします",
        },
        search_material_chapter_prev: {
            key: "",
            text: "左の選択されている章より前の章を、全て ON にします<br>7章のみが選択されている状態でこのボタンをクリックすると<br>2～7章が ON になります",
        },
        search_material_chapter_after: {
            key: "",
            text: "左の選択されている章より後の章を、全て ON にします<br>7章のみが選択されている状態でこのボタンをクリックすると<br>7～15章が ON になります",
        },

        search_appendix_help: {
            key: "",
            text: "資料の検索対象を設定します",
        },
        search_appendix_all: {
            key: "",
            text: "資料のすべての文章を検索の対象とします",
        },
        search_appendix_heading: {
            key: "",
            text: "資料の見出しの部分のみを検索の対象とします",
        },
        search_appendix_none: {
            key: "",
            text: "資料を検索の対象としません",
        },

        search_load_help: {
            key: "",
            text: "保存した検索設定を呼び出します<br>呼び出して良ければ確認パネルの OK をクリックして下さい",
        },
        search_load_setting1: {
            key: "",
            text: "設定1 に保存した検索設定を呼び出します",
        },
        search_load_setting2: {
            key: "",
            text: "設定2 に保存した検索設定を呼び出します",
        },
        search_load_setting3: {
            key: "",
            text: "設定3 に保存した検索設定を呼び出します",
        },
        search_load_setting4: {
            key: "",
            text: "設定4 に保存した検索設定を呼び出します",
        },
        search_load_setting5: {
            key: "",
            text: "設定5 に保存した検索設定を呼び出します",
        },
        search_load_default: {
            key: "",
            text: "検索設定を初期設定に戻します",
        },

        search_save_help: {
            key: "",
            text: "現在の検索設定を保存します<br>呼び出して良ければ確認パネルの OK をクリックして下さい",
        },
        search_save_setting1: {
            key: "",
            text: "現在の検索設定を 設定1 に保存します",
        },
        search_save_setting2: {
            key: "",
            text: "現在の検索設定を 設定2 に保存します",
        },
        search_save_setting3: {
            key: "",
            text: "現在の検索設定を 設定3 に保存します",
        },
        search_save_setting4: {
            key: "",
            text: "現在の検索設定を 設定4 に保存します",
        },
        search_save_setting5: {
            key: "",
            text: "現在の検索設定を 設定5 に保存します",
        },

        config_close: {
            key: "e",
            text: "設定画面を閉じます",
        },
        config_button_help: {
            key: "",
            text: "教材のボタンの表示方法を設定します",
        },
        config_button_disptype_chapter_help: {
            key: "",
            text: "章の選択ボタンの表示方法を設定します",
        },
        config_button_disptype_chapter_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_chapter_simple: {
            key: "",
            text: "章の数字だけを表示します",
        },
        config_button_disptype_appendix_help: {
            key: "",
            text: "資料、検索、設定ボタンの表示方法を設定します",
        },
        config_button_disptype_appendix_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_appendix_simple: {
            key: "",
            text: "先頭の 1 文字だけを表示します",
        },
        config_button_disptype_description_help: {
            key: "",
            text: "説明文と実行結果を表示するボタンの表示方法を設定します",
        },
        config_button_disptype_description_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_description_simple: {
            key: "",
            text: "先頭の 1 文字だけを表示します",
        },
        config_button_disptype_lang_help: {
            key: "",
            text: "表示するプログラムの種類を選択するボタンの表示方法を設定します",
        },
        config_button_disptype_lang_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_lang_simple: {
            key: "",
            text: "先頭の 1 文字だけを表示します",
        },
        config_button_disptype_execute_help: {
            key: "",
            text: "再実行、デバッグボタンの表示方法を設定します",
        },
        config_button_disptype_execute_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_execute_simple: {
            key: "",
            text: "ボタンの幅が短くなるような表示を行います",
        },
        config_button_disptype_execute_letter: {
            key: "",
            text: "先頭の 1 文字だけを表示します",
        },
        config_button_disptype_diff_help: {
            key: "",
            text: "比較、コメント、比較ボックス、クリップボードと比較、ファイルと比較、コピーボタンの表示方法を設定します",
        },
        config_button_disptype_diff_normal: {
            key: "",
            text: "通常の表示を行います",
        },
        config_button_disptype_diff_simple: {
            key: "",
            text: "ボタンの幅が短くなるような表示を行います",
        },
        config_button_disptype_diff_letter: {
            key: "",
            text: "先頭の 1 文字だけを表示します",
        },
        config_button_default: {
            key: "",
            text: "設定を初期設定に戻します",
        },
        config_button_delete_history: {
            key: "",
            text: "教材の表示の履歴を削除します",
        },
        config_description_maxheight_help: {
            key: "",
            text: "ウェブページの表示領域の高さが足りないため、説明文が表示しきれない場合の、説明文の表示の最大の高さを設定します。<br>設定値は、ウェブページの表示領域（デベロッパーツールの部分は除きます）の高さに対する割合です。",
        },
        config_description_maxheight_25: {
            key: "",
            text: "説明文の表示の最大高さを 25% に設定します",
        },
        config_description_maxheight_30: {
            key: "",
            text: "説明文の表示の最大高さを 30% に設定します",
        },
        config_description_maxheight_35: {
            key: "",
            text: "説明文の表示の最大高さを 35% に設定します",
        },
        config_description_maxheight_40: {
            key: "",
            text: "説明文の表示の最大高さを 40% に設定します",
        },
        config_description_maxheight_45: {
            key: "",
            text: "説明文の表示の最大高さを 45% に設定します",
        },
        config_description_maxheight_50: {
            key: "",
            text: "説明文の表示の最大高さを 50% に設定します",
        },
        config_description_maxheight_55: {
            key: "",
            text: "説明文の表示の最大高さを 55% に設定します",
        },
        config_description_maxheight_60: {
            key: "",
            text: "説明文の表示の最大高さを 60% に設定します",
        },
        config_description_maxheight_65: {
            key: "",
            text: "説明文の表示の最大高さを 65% に設定します",
        },
        config_description_maxheight_70: {
            key: "",
            text: "説明文の表示の最大高さを 70% に設定します",
        },
        config_description_maxheight_75: {
            key: "",
            text: "説明文の表示の最大高さを 75% に設定します",
        },
        config_default: {
            key: "",
            text: "設定を初期設定に戻します",
        },
        delete_history: {
            key: "",
            text: "教材の表示の履歴を削除します",
        },

        desc_prev: {
            key: "c",
            text: "一つ前のルールなどの表示へ戻ります",
        },
        desc_minmax: {
            key: "r",
            text: "説明文の表示を最小化します。最小化後に、<br>上部に表示される「説明文」ボタンを<br>クリックすると再び表示されるようになります",
        },

        diff_minus: {
            key: ",",
            text: "修正された部分の前後に表示するプログラムの行数を 1 つ減らします。最小値は1です",
        },
        diff_plus: {
            key: ".",
            text: "修正された部分の前後に表示するプログラムの行数を 1 つ増やします。最大値は1000です",
        },
        diff_num: {
            key: "",
            text: "修正された部分の前後に表示するプログラムの行数を設定するテキストボックスです。1~1000 の範囲の整数を設定できます",
        },
        diff_default: {
            key: "/",
            text: "修正された部分の前後に表示するプログラムの行数を初期設定の 4 に設定します",
        },
        diff_max: {
            key: "\\",
            text: "修正された部分の前後に表示するプログラムの行数を最大値の 1000 に設定します",
        },
    };

    help_margin = 5;

    constructor(sc) {
        this.showCode = sc;
        this.keytable = {}
        for (let id in this.data) {
            if (typeof this.data[id] !== "string") {
                this.keytable[this.data[id].key] ||= [];
                this.keytable[this.data[id].key].push(id);
            }
        }
        document.addEventListener('keydown', (evt) => {
            //console.log(evt.key);
            if (this.showCode.param.shortcut || evt.key === this.data.shortcut_button.key) {
                let idlist = this.keytable[evt.key] || [];
                for (let id of idlist) {
                    if (id && $(`#${id}`).css("display") !== "none" && $(`#${id}`).css("visibility") !== "hidden") {
                        $(`#${id}`).removeClass("selected");
                        $(`#${id}`).addClass("active");
                        break;
                    }
                }
            }
        });
        document.addEventListener('keyup', (evt) => {
            //console.log(evt.key);
            if (this.showCode.param.shortcut || evt.key === this.data.shortcut_button.key) {
                let idlist = this.keytable[evt.key] || [];
                for (let id of idlist) {
                    if (id && $(`#${id}`).css("display") !== "none" && $(`#${id}`).css("visibility") !== "hidden") {
                        $(`#${id}`).removeClass("active");
                        $(`#${id}`).click();
                        break;
                    }
                }
            }
        });
    }

    sethelp() {
        let help = $("#help");
        for (let id in this.data) {
            let elem = $(`#${id} `);
            if (this.showCode.param.help) {
                elem.addClass("help_enabled");
            }
            else {
                elem.removeClass("help_enabled");
            }
            elem.off("mouseenter");
            elem.on("mouseenter", (evt) => {
                if (this.showCode.param.help) {
                    help.removeClass("hidden");
                    help.addClass("invisible");
                    let text = this.data[id].text;
                    if (this.data[id].key !== "") {
                        let key = this.data[id].key.toUpperCase();
                        if (key === "\\") {
                            key = "＼";
                        }
                        text = `(${key}) ${text}`;
                    }
                    help.html(text);
                    help.css({
                        left: "auto",
                        top: "auto",
                        right: "auto",
                        bottom: "auto",
                        "max-width": $(window).width() - this.help_margin * 2,
                    })
                    help.offset({ top: $(window).scrollTop() * 0, left: $(window).scrollLeft() * 0 });
                    requestAnimationFrame(this.showhelp.bind(this, help, elem));
                }
            });
            elem.off("mouseout");
            elem.on("mouseout", (evt) => {
                help.addClass("hidden");
            });
        }
    }

    showhelp(help, elem) {
        const scrollLeft = $(window).scrollLeft();
        const scrollTop = $(window).scrollTop();
        const offset = elem.offset();

        const htmlWidth = $("html").outerWidth();
        const htmlHeight = $("html").outerHeight();

        const winWidth = $(window).width();
        const winHeight = $(window).height();

        const leftWidth = offset.left - scrollLeft;
        const rightWidth = scrollLeft + winWidth - (offset.left + elem.outerWidth());
        const topHeight = offset.top - scrollTop;
        const bottomHeight = scrollTop + winHeight - (offset.top + elem.outerHeight());
        const underRightWidth = scrollLeft + winWidth - offset.left;
        const sideBottomHeight = scrollTop + winHeight - offset.top;

        const helpWidth = help.outerWidth();
        const helpHeight = help.outerHeight();

        let left = "auto", top = "auto", right = "auto", bottom = "auto";

        // 左右に表示できるかどうか
        let side = null;
        if (leftWidth >= helpWidth + this.help_margin * 2) {
            side = "left";
        }
        if (rightWidth >= helpWidth + this.help_margin * 2) {
            if (side === null || leftWidth < rightWidth) {
                side = "right";
            }
        }

        // 上下に表示する（左右に表示できない場合は、下に表示する）
        if (side === null || bottomHeight >= helpHeight + this.help_margin * 2 || topHeight >= helpHeight + this.help_margin * 2) {
            if (side === null || bottomHeight >= helpHeight + this.help_margin * 2) {
                top = offset.top + elem.outerHeight() + this.help_margin;
            }
            else {
                top = offset.top - helpHeight - this.help_margin;
            }
            // elem の直下または、直情に表示できるかどうか
            if (underRightWidth >= helpWidth + this.help_margin) {
                left = offset.left;
            }
            else {
                right = htmlWidth - (scrollLeft + winWidth) + this.help_margin;
            }
        }
        // に表示できるかどうか
        else {
            if (side === "left") {
                left = offset.left - helpWidth - this.help_margin * 2;
            }
            else {
                right = htmlWidth - (offset.left + elem.outerWidth() + helpWidth + this.help_margin);
            }
            if (sideBottomHeight >= helpHeight) {
                top = offset.top;
            }
            else {
                top = offset.top - (helpHeight - sideBottomHeight);
                if (top < scrollTop) {
                    top = scrollTop + this.help_margin;
                }
            }
        }

        help.css({
            left: left, top: top, right: right, bottom: bottom,
        });
        help.removeClass("invisible");
    }
}